stages:
  - build
  - deploy

image: registry.gitlab.com/innovate-tech/infrasturcture/ci-images/nodejs:latest

.build_template: &build_def
  stage: build
  script:
    - bash apps/jeli-site/.ci/build.sh
  interruptible: true

  artifacts:
    public: true
    reports:
      dotenv: build.env
    paths:
      - apps/jeli-site/public
    expire_in: 1 hour
    when: on_success
  cache:
    key: jeli
    paths:
      - node_modules
    policy: pull

.deploy_template: &deploy_def
  stage: deploy
  interruptible: true
  image: registry.gitlab.com/gitlab-org/cloud-deploy/aws-base:latest
  dependencies:
    - build
  script:
    - bash apps/jeli-site/.ci/deploy.sh

build:
  <<: *build_def
  environment: $CI_COMMIT_BRANCH
  only:
    variables:
      - $CI_COMMIT_REF_PROTECTED == "true"

deploy-devs:
  <<: *deploy_def
  environment:
    name: $CI_COMMIT_BRANCH
  needs:
    - job: build
      artifacts: true
  only:
    refs:
      - '/^(.*)([0-9a-z]-+)?(development|staging)$/'
    variables:
      - $CI_COMMIT_REF_PROTECTED == "true"

deploy-prod:
  stage: deploy
  <<: *deploy_def
  environment:
    name: $CI_COMMIT_BRANCH
  when: manual
  needs:
    - job: build
      artifacts: true
  only:
    refs:
      - '/^(?:[a-z-]+)?(production|nepal|alston)$/'
    variables:
      - $CI_COMMIT_REF_PROTECTED == "true"
